function [l1, h, s2, s3]= fram4_down_hmwf(l,H,M)
%one step of 4-channel frame decomposition of a signal or an array of row signals 'l'

%H and M --transform filters (produced by function 'hmwf.m')
%l1, h --the low-, high-pass transform coefficients
%s2 and s3--the  band-pass transform coefficients


[e o]=evod(l);
fe=fft(e,[],2);
fo=fft(o,[],2);


fl1=fe.*H{1,1}+fo.*H{1,2};
   fh=fe.*H{2,1}+fo.*H{2,2};
  l1=real(ifft(fl1,[],2)); 
 h=real(ifft(fh,[],2));

fs2=fe.*M{1,1}+fo.*M{1,2};
fs3=fe.*M{2,1}+fo.*M{2,2};
    s2=real(ifft(fs2,[],2));
s3=real(ifft(fs3,[],2));
% Copyright (c) 2013. Valery A. Zheludev
